

 //Load jQuery library using plain JavaScript
(function(){
if (typeof jQuery === 'undefined') {
  var newscript = document.createElement('script');
  newscript.type = 'text/javascript';
  newscript.src = 'http://ajax.googleapis.com/ajax/libs/jquery/1.8.1/jquery.min.js';
    newscript.onreadystatechange= function () {
      if (this.readyState == 'complete') Main();
   };
  var myHead = document.getElementsByTagName('head')[0];
  myHead.parentNode.insertBefore(newscript,myHead);
  setTimeout('Main()',4000);

  }
  else
  {
	Main();
   }
  
})();


 
var FlyJSONP = (function (global) {
    "use strict";
    /*jslint bitwise: true*/
    var self,
        addEvent,
        garbageCollectGet,
        parametersToString,
        generateRandomName,
        callError,
        callSuccessGet,
        callSuccessPost,
        callComplete;
    
    addEvent = function (element, event, fn) {
        if (element.addEventListener) {
            element.addEventListener(event, fn, false);
        } else if (element.attachEvent) {
            element.attachEvent('on' + event, fn);
        } else {
            element['on' + event] = fn;
        }
    };
    
    garbageCollectGet = function (callbackName, script) {
        self.log("Garbage collecting!");
        script.parentNode.removeChild(script);
        global[callbackName] = undefined;
        try {
            delete global[callbackName];
        } catch (e) { }
    };
    
    parametersToString = function (parameters, encodeURI) {
        var str = "",
            key,
            parameter;
            
        for (key in parameters) {
            if (parameters.hasOwnProperty(key)) {
                key = encodeURI ? encodeURIComponent(key) : key;
                parameter = encodeURI ? encodeURIComponent(parameters[key]) : parameters[key];
                str += key + "=" + parameter + "&";
            }
        }
        return str.replace(/&$/, "");
    };
    
    //Thanks to Kevin Hakanson
    //http://stackoverflow.com/questions/105034/how-to-create-a-guid-uuid-in-javascript/873856#873856
    generateRandomName = function () {
        var uuid = '',
            s = [],
            hexDigits = "0123456789ABCDEF",
            i = 0;
            
        for (i = 0; i < 32; i += 1) {
            s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
        }
        
        s[12] = "4";  // bits 12-15 of the time_hi_and_version field to 0010
        s[16] = hexDigits.substr((s[16] & 0x3) | 0x8, 1);  // bits 6-7 of the clock_seq_hi_and_reserved to 01

        uuid = 'flyjsonp_' + s.join("");
        return uuid;
    };
    
    callError = function (callback, errorMsg) {
        self.log(errorMsg);
        if (typeof (callback) !== 'undefined') {
            callback(errorMsg);
        }
    };
    
    callSuccessGet = function (callback, data) {
        self.log("GET success");
        if (typeof (callback) !== 'undefined') {
            callback(data);
        }
        self.log(data);
    };
    
    callSuccessPost = function (callback, data) {
        self.log("POST success");
        if (typeof (callback) !== 'undefined') {
            callback(data);
        }
        self.log(data);
    };
    
    callComplete = function (callback) {
        self.log("Request complete");
        if (typeof (callback) !== 'undefined') {
            callback();
        }
    };
    
    self = {};
    
    //settings
    self.options = {
        debug: false
    };
    
    self.init = function (options) {
        var key;
        self.log("Initializing!");
        
        for (key in options) {
            if (options.hasOwnProperty(key)) {
                self.options[key] = options[key];
            }
        }
        
        self.log("Initialization options");
        self.log(self.options);
        return true;
    };
    
    self.log = function (log) {
        if (global.console && self.options.debug) {
            global.console.log(log);
        }
    };
    
    self.get = function (options) {
        options = options || {};
        var url = options.url,
            callbackParameter = options.callbackParameter || 'callback',
            parameters = options.parameters || {},
            script = global.document.createElement('script'),
            callbackName = generateRandomName(),
            prefix = "?";
            
        if (!url) {
            throw new Error('URL must be specified!');
        }
        
        parameters[callbackParameter] = callbackName;
        if (url.indexOf("?") >= 0) {
            prefix = "&";
        }
        url += prefix + parametersToString(parameters, true);
        
        global[callbackName] = function (data) {
            if (typeof (data) === 'undefined') {
                callError(options.error, 'Invalid JSON data returned');
            } else {
                if (options.httpMethod === 'post') {
                    data = data.query.results;
                    if (!data || !data.postresult) {
                        callError(options.error, 'Invalid JSON data returned');
                    } else {
                        if (data.postresult.json) {
                            data = data.postresult.json;
                        } else {
                            data = data.postresult;
                        }
                        callSuccessPost(options.success, data);
                    }
                } else {
                    callSuccessGet(options.success, data);
                }
            }
            garbageCollectGet(callbackName, script);
            callComplete(options.complete);
        };
        
        self.log("Getting JSONP data");
        script.setAttribute('src', url);
        global.document.getElementsByTagName('head')[0].appendChild(script);
        
        addEvent(script, 'error', function () {
            garbageCollectGet(callbackName, script);
            callComplete(options.complete);
            callError(options.error, 'Error while trying to access the URL');
        });
    };
    
    self.post = function (options) {
        options = options || {};
        var url = options.url,
            parameters = options.parameters || {},
            yqlQuery,
            yqlURL,
            getOptions = {};
        
        if (!url) {
            throw new Error('URL must be specified!');
        }
        
        yqlQuery =  encodeURIComponent('select * from jsonpost where url="' + url + '" and postdata="' + parametersToString(parameters, false) + '"');
        yqlURL = 'http://query.yahooapis.com/v1/public/yql?q=' + yqlQuery + '&format=json' + '&env=' + encodeURIComponent('store://datatables.org/alltableswithkeys');
        
        getOptions.url = yqlURL;
        getOptions.httpMethod = 'post';
        
        if (typeof (options.success) !== 'undefined') {
            getOptions.success = options.success;
        }
        
        if (typeof (options.error) !== 'undefined') {
            getOptions.error = options.error;
        }
        
        if (typeof (options.complete) !== 'undefined') {
            getOptions.complete = options.complete;
        }
        
        self.get(getOptions);
    };
    
    return self;
}(this));

function GetAndPopulateCookies()
{
var myRDC = new ReferralDataCookies();
var cookieName;
var cookieValue;
var l = 0;
var foundElement = 0;
var elementsToLookFor = ["ip","IP","pmid","PMID","ref","REF","aspx_referer","ASPX_REFERER","tc","TC","pckid","Pckid","PckId","PCKID","utm_source","UTM_SOURCE","utm_campaign","UTM_CAMPAIGN","utm_medium","UTM_MEDIUM","uid","UID","Uid","U","u"];
for(l=0; l < elementsToLookFor.length ; l++)
{
	if (document.getElementById(elementsToLookFor[l]) != "" && document.getElementById(elementsToLookFor[l]) != null) {
		cookieValue = document.getElementById(elementsToLookFor[l]);
		cookieName = elementsToLookFor[l].toLowerCase();
		if (cookieName == "u")
		{
			cookieName = "uid";
		}
		myRDC.setCookie(cookieName, cookieValue, 30, "/", domainName, secureSite);
		foundElement = 1;
	}
	
	if (foundElement == 0  && getParameterByName(elementsToLookFor[l]) != "" && getParameterByName(elementsToLookFor[l]) != null) {
		cookieValue = getParameterByName(elementsToLookFor[l]);
		cookieName = elementsToLookFor[l].toLowerCase();
		if (cookieName == "u")
		{
			cookieName = "uid";
		}
		myRDC.setCookie(cookieName, cookieValue, 30, "/", domainName, secureSite);
		foundElement = 1;
	}
	if (foundElement == 0  && $('input[name="'+elementsToLookFor[l]+'"]').val() != "" && $('input[name="'+elementsToLookFor[l]+'"]').val() != null) {
		cookieValue = $('input[name="'+elementsToLookFor[l]+'"]').val();
		cookieName = elementsToLookFor[l].toLowerCase();
		if (cookieName == "u")
		{
			cookieName = "uid";
		}
		myRDC.setCookie(cookieName, cookieValue, 30, "/", domainName, secureSite);
		foundElement = 1;
	}
	//TODO: Find a way to get IP other than query string and form variables. Have to get it from the client machine
	if (elementsToLookFor[l].toLowerCase() == "ip")
	{
		cookieName = "ip"
		cookieValue = IPAddress;
		myRDC.setCookie(cookieName, cookieValue, 30, "/", domainName, secureSite);
		foundElement = 1;
	}

	if(foundElement == 1)
	{
		if(elementsToLookFor[l].toLowerCase() == "ip")
			ip = cookieValue;
		else if(elementsToLookFor[l].toLowerCase() == "pmid")
			pmid = cookieValue;
		else if(elementsToLookFor[l].toLowerCase() == "ref")
			ref = cookieValue;
		else if(elementsToLookFor[l].toLowerCase() == "aspx_referer")
			aspx_referer = cookieValue;
		else if(elementsToLookFor[l].toLowerCase() == "tc")
			tc = cookieValue;
		else if(elementsToLookFor[l].toLowerCase() == "pckid")
			pckid = cookieValue;
		else if(elementsToLookFor[l].toLowerCase() == "utm_source")
			utm_source = cookieValue;
		else if(elementsToLookFor[l].toLowerCase() == "utm_campaign")
			utm_campaign = cookieValue;
		else if(elementsToLookFor[l].toLowerCase() == "utm_medium")
			utm_medium = cookieValue;
		else if(elementsToLookFor[l].toLowerCase() == "uid" || elementsToLookFor[l].toLowerCase() == "u")
			uid = cookieValue;
		foundElement = 0;
	}
}
}

function writeForms() 
{
    var i = 0; var j = 0; var k = 0;
    var myarray = ["ip","pmid","ref","aspx_referer","tc","pckid","utm_source","utm_campaign","utm_medium","uid"];
    for (i = 0; i < document.forms.length; i++) 
	{
		var myform = document.forms[i]; 
        if (myform.action.indexOf("register.asp") > 0 || myform.action.indexOf("emailsignup.aspx") > 0) 
        {
			for (k =0 ; k < myarray.length; k++)
			{					
				var flag = 0;
				for (j = 0; j < myform.elements.length; j++)  
				{						
					if (myform.elements[j].name.toLowerCase() ==  myarray[k])
					{
						flag = 1;  						
						if (myform.elements[j].value == "" && FindValueinObject(myarray[k]) != null && FindValueinObject(myarray[k]) != "")
							myform.elements[j].value = FindValueinObject(myarray[k]);														
					}                
				}				
				if (flag == 0 && FindValueinObject(myarray[k]) != null && FindValueinObject(myarray[k]) != "") 
				{
					addElement(myarray[k], FindValueinObject(myarray[k]), myform);
				}
			}
		}
	}
}	

function addElement(name, value, form) {
    var element = document.createElement("input");
    element.setAttribute("type", "hidden");
    element.setAttribute("name", name);
    element.setAttribute("value", value);
    form.appendChild(element);
}

function getCurrentIPAddress() {
        if (window.XMLHttpRequest) xmlhttp = new XMLHttpRequest();
        else xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");

        xmlhttp.open("GET", "http://api.hostip.info/get_html.php", false);
        xmlhttp.send();

        hostipInfo = xmlhttp.responseText.split("\n");

        for (i = 0; hostipInfo.length >= i; i++) {
            ipAddress = hostipInfo[i].split(":");
            if (ipAddress[0] == "IP") {
                return ipAddress[1];
            }
        }

        return 0;
    }

function trim(s)
{
	return rtrim(ltrim(s));
}

function ltrim(s)
{
	var l=0;
	while(l < s.length && s[l] == ' ')
	{	l++; }
	return s.substring(l, s.length);
}

function rtrim(s)
{
	var r=s.length -1;
	while(r > 0 && s[r] == ' ')
	{	r-=1;	}
	return s.substring(0, r+1);
}

function getParameterByName(name) {
    name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
    var regexS = "[\\?&]" + name + "=([^&#]*)";
    var regex = new RegExp(regexS);
    var results = regex.exec(window.location.search);
    if (results == null)
        return "";
    else
        return trim(decodeURIComponent(results[1].replace(/\+/g, " ")));
}

function ReferralDataCookies()
{
this.setCookie = setCookie;
this.getCookies = getCookies;

function setCookie(c_name, value, exdays, path, domain, secure) {
    FlyJSONP.init({ debug: true });
    FlyJSONP.get({
    url: 'https://www.streetauthority.net/tsa/WriteCookies.aspx?' + c_name + "=" + value,
        success: function(data) {
            console.log(data);
            
        },
        error: function(errorMsg) {
            console.log(errorMsg);
        }
    });
}

function getCookies()
{
    FlyJSONP.init({ debug: true });
    FlyJSONP.get({
	url: 'https://www.streetauthority.net/tsa/ReadCookies.aspx',
        success: function(data) {		
		mydata =   data;
        },
        error: function(errorMsg) {
            console.log(errorMsg);
        }
    });
}
};

function FindValueinObject(valueToFind) 
{
	if (valueToFind == "ip")
	{
		if(mydata != null)
		{
			if(mydata.ip != null && mydata.ip != "") 
				return mydata.ip; 
			else 
				return ip;
		}
		else 
			return ip;
			
	}
	if (valueToFind == "pmid")
	{
		if(mydata != null)
		{
			if(mydata.pmid != null && mydata.pmid != "") 
				return mydata.pmid;
			else 
				return pmid;
		}
		else 
			return pmid;
	}
	if (valueToFind == "ref")
	{
		if(mydata != null) 
		{
			if(mydata.ref != null && mydata.ref != "") 
				return mydata.ref;
			else 
				return ref;
		}
		else 
			return ref;
	}
	if (valueToFind == "aspx_referer")
	{
		if(mydata != null) 
		{
			if(mydata.aspx_referer != null && mydata.aspx_referer != "") 
				return mydata.aspx_referer;
			else 
				return aspx_referer;
		}
		else 
			return aspx_referer;
	}
	if (valueToFind == "tc")
	{
		if(mydata != null) 
		{
			if(mydata.tc != null && mydata.tc != "") 
				return mydata.tc;
			else 
				return tc;
		}
		else 
			return tc;
	}
	if (valueToFind == "pckid")
	{
		if(mydata != null)
		{
			if(mydata.pckid != null && mydata.pckid != "") 
				return mydata.pckid;
			else 
				return pckid;
		}
		else 
			return pckid;
	}
	if (valueToFind == "utm_source")
	{
		if(mydata != null)
		{
			if(mydata.utm_source != null && mydata.utm_source != "") 
				return mydata.utm_source;
			else 
				return utm_source;
		}
		else 
			return utm_source;
	}
	if (valueToFind == "utm_campaign")
	{
		if(mydata != null)
		{
			if(mydata.utm_campaign != null && mydata.utm_campaign != "") 
				return mydata.utm_campaign;
			else 
				return utm_campaign;
		}
		else 
			return utm_campaign;
	}
	if (valueToFind == "utm_medium")
	{
		if(mydata != null)
		{
			if(mydata.utm_medium != null && mydata.utm_medium != "") 
				return mydata.utm_medium;
			else 
				return utm_medium;	
		}
		else 
			return utm_medium;
	}
	if (valueToFind == "uid")
	{
		if(mydata != null)
		{
			if(mydata.uid != null && mydata.uid != "") 
				return mydata.uid;
			else 
				return uid;	
		}
		else 
			return uid;
	} 
}


var ref;
var IPAddress = "110.54.249.69";
var aspx_referer;
var pmid;
var tc;
var pckid;
var utm_source;
var utm_campaign;
var utm_medium;
var ip;
var uid;
var domainName = ".streetauthority.com";
var secureSite = "";
var mydata;
function  Main() {	
//
$(document).ready(function() {
GetAndPopulateCookies();
if(document.forms.length  > 0)
	{
	var myRDC = new ReferralDataCookies();	
	myRDC.getCookies();
	writeForms();
	}
});
}
