/* 
 * Author: Lonny Burgos
 * Description: This script manages Tracking Code Cookies. It uses and object
 * to run through all the cookies and leave only one standard TC cookie.
 */

//Create the Object
function CookieManagment(){
  //Instantiate all behaviors
  this.create_Cookie= create_Cookie;
  this.get_Cookie = get_Cookie;
  this.seek_destroy_Cookie= seek_destroy_Cookie;
  this.delete_Cookie= delete_Cookie;

  function create_Cookie(name,value,days)
  {
    /*
     * Function to create a cookie.
     * If days is set to 0 the cookie is trashed when the user closes the browser.
     * If days is negative the cookie is trashed immediately.
     * If days is positive the cookie is active for that many days.
     */
    
    if (days)
    {
      var date = new Date();
      date.setTime(date.getTime()+(days*24*60*60*1000));
      var expires = "; expires="+date.toGMTString();
    }
    
    else var expires = "";
    document.cookie = name+"="+value+expires+"; path=/";
  }   

  
  function get_Cookie(name)
  {
    /*
     * Function to get the cookie information.
     * Checks if the cookie exists.
     * If the cookie exists, then return the value of the cookie.
     * If not, then the function returns null.
     */
    
    var nameEQ = name + "=";
    var ca = document.cookie.split(';');
    for(var i=0; i < ca.length; i++){
      var c = ca[i];
      while(c.charAt(0)==' ') c = c.substring(1, c.length);
      if (c.indexOf(nameEQ)== 0 ) 
        return c.substring(nameEQ.length, c.length);
      }
    return null;
  }


  function seek_destroy_Cookie()
  {
   //Create an array of possible cookie names. 
   var cookieNames = ["TC", "tc", "Tc", "tC"];
   
   //Create a variable to store the cookie value.
   var cookieValue = null;
   

   //Seek all the cookies that are in the cookie names array.
   for(i=0; i<cookieNames.length; i++)
     {
       //Set the cookie value of each possible cookie name.
       cookieValue= get_Cookie(cookieNames[i]);
       // PRINT OUT WHEN DEBUGGING
       if (SASysdebug == 1) {alert(cookieNames[i]+"="+cookieValue ); }
       //Check the cookie value, if it not null then the cookie exists.
       if(cookieValue !== null)
       {
         //Check the cookie value again to see if it blank.
         if(cookieValue == "")
           {
             //Delete all blank TC cookies.
             delete_Cookie(cookieNames[i]);
           }
           //If the cookie valuse is not blank then the cookie is valid.
           else if (cookieValue != "")
             {
               //Check to see if the cookie is already uppercase.
               if(cookieNames[i] == "TC")
                 {
                   //Delete all other possible cookie names if TC uppercase exists
                   delete_Cookie(cookieNames[1]);
                   delete_Cookie(cookieNames[2]);
                   delete_Cookie(cookieNames[3]);
                   
                 }
                 //If it not uppercase
                 else if(cookieNames[i] != "TC")
                 {
                   //Create a cookie with the first TC value we find and delete the rest
                   create_Cookie(cookieNames[0], cookieValue, 7);
                   delete_Cookie(cookieNames[1]);
                   delete_Cookie(cookieNames[2]);
                   delete_Cookie(cookieNames[3]);
                 }
             }
            
       	}
       	
       	//Check the cookie value if it is null then delete it
       	else if(cookieValue == null)
       	{
       		delete_Cookie(cookieNames[i]);
       	}
     }
 
   }

  function delete_Cookie(name) 
  {
    /*
     * Function to delete unwanted cookies.
     */
    create_Cookie(name,"",-1);
  }

}

//Instantiate the cookie managment object.
var CM = new CookieManagment();

//Call behavior to manage cookies.
$(document).ready(function() {
   if (SASysdebug == 1) {
	   alert(document.domain);
	CM.seek_destroy_Cookie();
	}
});