/**
* jwvideoplayercontrols.js
* This file contains evertything you will need to control the JWplayer on a page.
* 
* Copyright (c) StreetAuthority.com <http://www.streetauthority.com/>.
*   
*/


var GAID = "";
var hostName = window.location.protocol + "//" + window.location.host;
var scrollBool = 0;

// Major version of Flash required
var requiredMajorVersion = 9;
// Minor version of Flash required
var requiredMinorVersion = 0;
// Minor revision of Flash required
var requiredRevision = 0;

// Version check based upon the values entered above in "Globals"



var readyStateCheckInterval = setInterval(function () {
    if (document.readyState === "complete") {
        if (typeof jQuery == 'undefined') {
            alert("Please link jquery.js in original article.");
        } else {
            jwVideoPlayerinit();
        }
        clearInterval(readyStateCheckInterval);
    }
}, 10);


function jwVideoPlayerinit() {
    //Run the boolean check and the jquery hide function on scroll
    checkScrollBool(scrollBool);

    /*Ajax call to replace the analytics code passing the hostname for the php lookup from cache */
    /*	$.getScript("http://web.streetauthority.com/PHPApplication/replaceAnalyticsCode.php?url=" + hostName,function(data,textStatus,jqxhr){ 
    console.log(data); //data returned
    console.log(textStatus); //success
    console.log(jqxhr.status); //200
    console.log('Load was performed.');
    });
    */
    /*These divs are initially defined*/
    $("#VideoContent").show();
    $("#TranscriptContent").hide();
    $("#SignMeUp").hide();
    $("#VideoFinishText").hide();
    $("#signupbox").hide();
    $("#faq").hide();
    $("#top10stocksheader").hide();
    $("#requireEmail").hide();
    /*Detect Flash Version from Browser*/

};

/*Function to hide the welcome div when scrolling
*@parameters: global boolean
*@returns: an integer
*@author: Lonny Burgos
*/
function welcomeScroll(scrollBool) {
    $(window).scroll(function () {
        $("#welcome").hide("slow");
    });
    return 1;
}

/*Function to check the scrolling boolean value
*@parameters: a boolean value
*@author: Lonny Burgos
*/
function checkScrollBool(scrollBool) {
    if (scrollBool == 0) {
        scrollBool = welcomeScroll(scrollBool);
    }
    else {
        return null;
    }
}



function require(script) {
    $.ajax({
        url: script,
        dataType: "script",
        async: false,           // <-- this is the key
        success: function () {
            // all good...
        },
        error: function () {
            throw new Error("Could not load script " + script);
        }
    });
}

function setCookie(name, value, days) {
    if (days) {
        var date = new Date();
        date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
        var expires = "; expires=" + date.toGMTString();
    }
    else var expires = "";
    document.cookie = name + "=" + value + expires + "; path=/";
}

function getCookie(name) {
    var nameEQ = name + "=";
    var ca = document.cookie.split(';');
    for (var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') c = c.substring(1, c.length);
        if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length, c.length);
    }
    return null;
}

function deleteCookie(name) {
    setCookie(name, "", -1);
}


function getParameterByName(name) {
    name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
    var regexS = "[\\?&]" + name + "=([^&#]*)";
    var regex = new RegExp(regexS);
    var results = regex.exec(window.location.href);
    if (results == null)
        return "";
    else
        return decodeURIComponent(results[1].replace(/\+/g, " "));
}


function FlashCheck(hasRequestedVersion) {
    // Check to see if the version meets the requirements for playback

    if (hasRequestedVersion) {
        // if we've detected an acceptable version
        // embed the Flash Content SWF when all tests are passed

        $("#TranscriptContent").hide();
        $("#VideoContent").show();
        $("#signupbox").hide();
        $("#VideoContainer").show();


    } else {  // flash is too old or we can't detect the plugin

        $("#TranscriptContent").show();
        $("#VideoContent").hide();
        $("#signupbox").show();
        $("#VideoContainer").hide();

    }

}

function Unloadhandler() {
    this.UnloadMessage = false;
    this.CustomMessage = false;
    this.ClearUnload = ClearUnload;
    this.CheckUnloadMessage = CheckUnloadMessage;

    function ClearUnload() {
        window.onbeforeunload = null;
    };


    function CheckUnloadMessage() {
        var detect = navigator.userAgent.toLowerCase();
        var OS, browser, version, total, thestring;
        if (/MSIE (\d+\.\d+);/.test(navigator.userAgent)) { //test for MSIE x.x;
            var ieversion = new Number(RegExp.$1) // capture x.x portion and store as a number
        }


        if (checkIt('konqueror')) {
            browser = "Konqueror";
            OS = "Linux";
        }
        else if (checkIt('chrome')) browser = "Chrome"
        else if (checkIt('safari')) browser = "Safari"
        else if (checkIt('firefox')) browser = "Firefox"
        else if (checkIt('omniweb')) browser = "OmniWeb"
        else if (checkIt('opera')) browser = "Opera"
        else if (checkIt('webtv')) browser = "WebTV";
        else if (checkIt('icab')) browser = "iCab"
        else if (checkIt('msie')) browser = "Internet Explorer"
        else if (!checkIt('compatible')) {
            browser = "Netscape Navigator"
            version = detect.charAt(8);
        }
        else browser = "An unknown browser";

        if (!version) version = detect.charAt(place + thestring.length);

        if (!OS) {
            if (checkIt('linux')) OS = "Linux";
            else if (checkIt('x11')) OS = "Unix";
            else if (checkIt('mac')) OS = "Mac"
            else if (checkIt('win')) OS = "Windows"
            else OS = "an unknown operating system";
        }

        function checkIt(string) {
            place = detect.indexOf(string) + 1;
            thestring = string;
            return place;
        }
        if (this.UnloadMessage == true && this.CustomMessage == true) {
            $(window).bind('beforeunload', function () {
                jwplayer().stop(true);

                this.UnloadMessage = false;
                $("#shade-box").show();
                $("#custom-message-box").show();
                $("#VideoContent").hide();
                $("#TranscriptContent").show();

                setTimeout(function () {
                    setTimeout(function () {
                        $("#shade-box").hide();
                        $("#custom-message-box").hide();
                    }, 1000);
                }, 1);
                if (browser == 'Chrome') {
                    return "You've chosen to exit our video presentation. Did you know that we also offer a free TEXT-ONLY version of this report? If you'd rather read the text version of this report, click \"Stay on this Page\" below. "
                }
                else if (browser == 'Internet Explorer' && ieversion == 6) {
                    return "You've chosen to exit our video presentation. Did you know that we also offer a free TEXT-ONLY version of this report? If you'd rather read the text version of this report, click \"Ok\" below. "
                }
                else if (browser == 'Internet Explorer' && ieversion == 7) {
                    return "You've chosen to exit our video presentation. Did you know that we also offer a free TEXT-ONLY version of this report? If you'd rather read the text version of this report, click \"Ok\" below. "
                }
                else if (browser == 'Internet Explorer' && ieversion == 8) {
                    return "You've chosen to exit our video presentation. Did you know that we also offer a free TEXT-ONLY version of this report? If you'd rather read the text version of this report, click \"Ok\" below. "
                }
                else if (browser == 'Internet Explorer' && ieversion == 9) {
                    return "You've chosen to exit our video presentation. Did you know that we also offer a free TEXT-ONLY version of this report? If you'd rather read the text version of this report, click \"Stay on this Page\" below. "
                }
                else if (browser = 'Safari') {
                    return "You've chosen to exit our video presentation. Did you know that we also offer a free TEXT-ONLY version of this report? If you'd rather read the text version of this report, click \"Ok\" below. "
                }

                else {
                    return "Do you really want to leave?";
                }


            });

        }

        else if (this.UnloadMessage == true && this.CustomMessage == false) {
            $(window).bind('beforeunload', function () {
                jwplayer().stop(true);

                this.UnloadMessage = false;
                $("#VideoContent").hide();
                $("#TranscriptContent").show();
                $('html,body').scrollTop($("#TranscriptContent").offset().top);
                if (browser == 'Chrome') {
                    return "You've chosen to exit our video presentation. Did you know that we also offer a free TEXT-ONLY version of this report? If you'd rather read the text version of this report, click \"Stay on this Page\" below. "
                }
                else if (browser == 'Internet Explorer' && ieversion == 6) {
                    return "You've chosen to exit our video presentation. Did you know that we also offer a free TEXT-ONLY version of this report? If you'd rather read the text version of this report, click \"Ok\" below. "
                }
                else if (browser == 'Internet Explorer' && ieversion == 7) {
                    return "You've chosen to exit our video presentation. Did you know that we also offer a free TEXT-ONLY version of this report? If you'd rather read the text version of this report, click \"Ok\" below. "
                }
                else if (browser == 'Internet Explorer' && ieversion == 8) {
                    return "You've chosen to exit our video presentation. Did you know that we also offer a free TEXT-ONLY version of this report? If you'd rather read the text version of this report, click \"Ok\" below. "
                }
                else if (browser == 'Internet Explorer' && ieversion == 9) {
                    return "You've chosen to exit our video presentation. Did you know that we also offer a free TEXT-ONLY version of this report? If you'd rather read the text version of this report, click \"Stay on this Page\" below. "
                }
                else if (browser = 'Safari') {
                    return "You've chosen to exit our video presentation. Did you know that we also offer a free TEXT-ONLY version of this report? If you'd rather read the text version of this report, click \"Ok\" below. "
                }

                else {
                    return "Do you really want to leave?";
                }

            });

        }

    }
};

function myVideoPlayer() {
    this.debugdata = false;
    this.enableS3HostingforProgressiveDownload = true;
    this.width = 600;
    this.height = 480;
    this.skin = '/javascript/mediaplayer-5.7/skins/satube/satube.xml';
    this.autostart = false;
    this.file = 'TTS/june-30-one-stock-short.mp4';
    this.initializeVideo = initializeVideo;
    this.onVideoComplete = onVideoComplete;
    this.containerName = "JwplayerContainer";
    this.Showbar = false;
    this.Image = "//web.streetauthority.com/javascript/mediaplayer-5.7/skins/sample.jpg";


    var detectVideoSupport = function () {
        var detect = document.createElement('video') || false;
        this.html5 = detect && typeof detect.canPlayType !== "undefined";
        this.mp4 = this.html5 && (detect.canPlayType("video/mp4") === "maybe" || detect.canPlayType("video/mp4") === "probably");
        this.ogg = this.html5 && (detect.canPlayType("video/ogg") === "maybe" || detect.canPlayType("video/ogg") === "probably");
        return this;
    };

    function initializeVideo(arr) {
        var videoDetection = detectVideoSupport(); /* DETECT HTML5 SUPPORT */
        var hasRequestedVersion = DetectFlashVer(requiredMajorVersion, requiredMinorVersion, requiredRevision); /* DETECT FLASH */
        var ControlBarSetting;
        /*Controls the Control Bar with a true/false variable*/
        var currenturl = location.pathname.split('/');
        var count = currenturl.length;
        var page = currenturl[count - 1];
        var lasttime, numPageReloads, timetoStoreCookie;
        timetoStoreCookie = 2; // store video preference cookies for 2 days
        numPageReloads = 5; // number of page reloads before we automatically show the transcript
        if (page[1] = 'index.php') { page = currenturl[count - 2]; }
        lasttime = getCookie('videotime_' + page); // assign the initial time they were running at
        if (getParameterByName("viddebug").toLowerCase() == "y") { this.Showbar = true; }  // load bar if videodebug
        if (parseFloat(getCookie('pagereloads_' + page)) > numPageReloads) { this.Showbar = true; this.autostart = true; } //we load bar if the user has had reload issus
        if (parseFloat(getCookie('pagereloads_' + page)) > 1) { this.autostart = true; } //autostart if they left and want to watch again
        if (this.Showbar == true) {
            ControlBarSetting = "bottom";
        }
        if (this.Showbar == false) {
            ControlBarSetting = "none";
        }
        else {
            ControlBarSetting = "bottom";
        }



        if (this.debugdata) { alert("file:" + this.file + ", Flash:" + hasRequestedVersion + ", Mp4: " + videoDetection.mp4); }
        /*If statement handles if the video file is Progressive Download or RTMP */
        if (this.file.indexOf('http') >= 0 || (this.enableS3HostingforProgressiveDownload && videoDetection.mp4 && !hasRequestedVersion)) /* must have mp4 capability and not able to see flash */
        {
          
            if (this.file.indexOf('http') < 0 && this.file.indexOf('.mp4') >= 0) { /* if no http we must be using amazon RTMP and also it should be a mp4 file */
                if (this.debugdata) { alert("loading file (" + this.file + "from AWS S3"); }
                this.file = 'http://s3.amazonaws.com/savideos/' + this.file /* LOAD THE S3 storage of the vide file  */
            }
            else {
                if (!hasRequestedVersion && !videoDetection.mp4 || (videoDetection.mp4 && this.file.indexOf('.mp4') < 0)) {
                    if (this.debugdata) { alert(" browser isn't version and cant play mp3 or can play mp4 but file isn't mp4 "); }
                    FlashCheck(hasRequestedVersion);
                }
            }
            jwplayer(this.containerName).setup(
		{
		    flashplayer: 'http://web.streetauthority.com/javascript/mediaplayer-5.7/player.swf',
		    file: this.file,
		    skin: this.skin,
		    height: this.height,
		    width: this.width,
		    image: this.Image,
		    controlbar: ControlBarSetting,
		    plugins: {
		        "gapro-2": {
		            trackstarts: true,
		            trackpercentage: true,
		            tracktime: true
		        }
		    },

		    events:
  			{
  			    onTime: function (event) {
  			        // save video position every 10 seconds , we will use this data later if the page is reloaded
  			        if (lasttime == null || (lasttime - event.position < -10)) {
  			            setCookie('videotime_' + page, event.position, timetoStoreCookie);
  			            lasttime = event.position; // set lasttime position to check in another 10 seconds
  			        }
  			        for (var i = 0; i < arr.length; i++) {

  			            if (event.position > arr[i].time) {
  			                if (arr[i].JWevent == 'show') {
  			                    $(arr[i].div).show();
  			                }
  			                if (arr[i].JWevent == 'hide') {
  			                    $(arr[i].div).hide();
  			                }
  			                if (arr[i].JWevent == 'focus') {
  			                    $(arr[i].div).focus();
  			                }
  			                if (arr[i].JWevent == 'animate') {
  			                    $(arr[i].div).animate(
			        			{
			        			    width: "75%",
			        			    fontSize: "13pt",
			        			    borderWidth: "4px"
			        			}, 1500);

  			                }

  			            }
  			        }
  			    }
  			}
		});

            jwplayer(this.containerName).onReady(function () {
                jwplayer(this.containerName).play(false);

                // CHECK TO SEE how many times this page has been reloaded
                if (getCookie('pagereloads_' + page) != null) {
                    setCookie('pagereloads_' + page, parseFloat(getCookie('pagereloads_' + page)) + 1, timetoStoreCookie);  // ASSIGN # of reloads of this page to their cookie
                    if (parseFloat(getCookie('pagereloads_' + page)) >= numPageReloads) // CHECK TO SEE IF ITS BEEN 3  or more
                    {
                        window.onbeforeunload = null; // disable onload handler
                        $('#TranscriptContent').show();
                        $('#TranscriptContent').prepend("<h3 class='video-load-error' style='color:red;'> We noticed you were having issues viewing our video. You can continue to <a href='javascript:void(0);' onclick=\"$('html,body').animate({scrollTop: $('body').offset().top},'slow');\"> view the video</a> above or read our transcript. Thank you!");
                        $('html,body').delay(2000).animate({ scrollTop: $("#TranscriptContent").offset().top }, 'slow');
                    }
                }
                else {
                    setCookie('pagereloads_' + page, 1, timetoStoreCookie); // Start it at 1 reload
                }
            });
        }

        else {
            /* IF WE ARE DOING RTMP we should check to make sure they can do flash */
            /* $(document).ready(function() {FlashCheck(hasRequestedVersion);}); */
            if (this.debugdata) { alert("loading RTMP (" + this.file + "from AWS CloudFront"); }
            jwplayer(this.containerName).setup(
			{
			    flashplayer: 'http://web.streetauthority.com/javascript/mediaplayer-5.7/player.swf',
			    streamer: 'rtmp://awsvideos.streetauthority.com/cfx/st',
			    file: this.file,
			    image: this.Image,
			    skin: this.skin,
			    height: this.height,
			    width: this.width,
			    controlbar: ControlBarSetting,
			    plugins: {
			        "gapro-2": {
			            accountid: GAID,
			            trackingobject: "pageTracker",
			            trackstarts: "true",
			            trackpercentage: "true",
			            tracktime: "true"
			        }
			    },


			    events:
						{
						    onTime: function (event) {
						        // save video position every 10 seconds , we will use this data later if the page is reloaded
						        if (lasttime == null || (lasttime - event.position < -10)) {
						            setCookie('videotime_' + page, event.position, timetoStoreCookie);
						            lasttime = event.position; // set lasttime position to check in another 10 seconds
						        }

						        if (getCookie('videoemail') != null) {						          
						            for (var i = 0; i < arr.length; i++) {
						                if (event.position > arr[i].time) {
						                    if (arr[i].JWevent.contain('pause')) {
						                        arr[i].JWevent.replace('pause', 'hide')
						                    }
						                }
						            }
						        }

						        for (var i = 0; i < arr.length; i++) {
						            if (event.position > arr[i].time) {
						                if (arr[i].JWevent == 'show') {
						                    $(arr[i].div).show();
						                }
						                if (arr[i].JWevent == 'hide') {
						                    $(arr[i].div).hide();
						                }
						                if (arr[i].JWevent == 'focus') {
						                    $(arr[i].div).focus();
						                }
						                if (arr[i].JWevent == 'pause') {						                  
						                    jwplayer(this.containerName).pause();
						                }
						                if (arr[i].JWevent == 'animate') {
						                    $(arr[i].div).animate(
											{
											    width: "75%",
											    fontSize: "13pt",
											    borderWidth: "4px"
											}, 1500);
						                }
						            }
						        }
						    }
						}
			});


			jwplayer(this.containerName).onReady(function () {
			    jwplayer(this.containerName).play(false);

			  
			    // CHECK TO SEE IF user was watching video before, and if so load from that point
			    if (getCookie('videotime_' + page) != null && parseFloat(getCookie('pagereloads_' + page)) < numPageReloads) {
			        if (confirm('Continue the video from where you last left off?')) {
			            jwplayer(this.containerName).seek(getCookie('videotime_' + page));
			        }
			    }

			    // CHECK TO SEE how many times this page has been reloaded
			    if (getCookie('pagereloads_' + page) != null) {
			        setCookie('pagereloads_' + page, parseFloat(getCookie('pagereloads_' + page)) + 1, timetoStoreCookie);  // ASSIGN # of reloads of this page to their cookie
			        if (parseFloat(getCookie('pagereloads_' + page)) >= numPageReloads) // CHECK TO SEE IF ITS BEEN 3  or more
			        {
			            window.onbeforeunload = null; // disable onload handler
			            $('#TranscriptContent').show();
			            $('#TranscriptContent').prepend("<h3 class='video-load-error' style='color:red;'> We noticed you were having issues viewing our video. You can continue to <a href='javascript:void(0);' onclick=\"$('html,body').animate({scrollTop: $('body').offset().top},'slow');\"> view the video</a> above or read our transcript. Thank you!");
			            $('html,body').delay(2000).animate({ scrollTop: $("#TranscriptContent").offset().top }, 'slow');
			        }
			    }
			    else {
			        setCookie('pagereloads_' + page, 1, timetoStoreCookie); // Start it at 1 reload
			    }
			});

        
        }

        if (this.autostart == true) {
            jwplayer(this.containerName).onReady(function () { jwplayer(this.containerName).play(true); });

        }
        if (this.autostart == false) {
            jwplayer(this.containerName).onReady(function () { jwplayer(this.containerName).play(false); });

        }
    };


    function onVideoComplete(arr2) {
        jwplayer(this.containerName).onComplete
	(
   		function (event2) {
   		    for (var i = 0; i < arr2.length; i++) {
   		        if (arr2[i].JWevent == 'show') {
   		            $(arr2[i].div).show();

   		        }
   		        if (arr2[i].JWevent == 'hide') {
   		            $(arr2[i].div).hide();
   		        }
   		        if (arr2[i].JWevent == 'focus') {
   		            $(arr2[i].div).focus();
   		        }
   		        if (arr2[i].JWevent == 'animate') {
   		            $(arr2[i].div).animate(
        			{
        			    width: "75%",
        			    fontSize: "13pt",
        			    borderWidth: "4px"
        			}, 1500);

   		        }

   		    }

   		}
   	)

    };


    function onVideoComplete(arr2) {
        jwplayer(this.containerName).onComplete
	(
   		function (event2) {
   		    for (var i = 0; i < arr2.length; i++) {
   		        if (arr2[i].JWevent == 'show') {
   		            $(arr2[i].div).show();
   		        }
   		        if (arr2[i].JWevent == 'hide') {
   		            $(arr2[i].div).hide();
   		        }
   		        if (arr2[i].JWevent == 'focus') {
   		            $(arr2[i].div).focus();
   		        }
   		        if (arr2[i].JWevent == 'animate') {
   		            $(arr2[i].div).animate(
        			{
        			    width: "75%",
        			    fontSize: "13pt",
        			    borderWidth: "4px"
        			}, 1500);

   		        }

   		    }

   		}
   	)

    };


    $(document).ready(function () {
        $('#requireEmail_submit').click(function () {
            var hasError = false;
            var emailReg = /^([\w-\.]+@([\w-]+\.)+[\w-]{2,4})?$/;
            var emailaddressVal = $("#requireEmail_email").val();

            if (emailaddressVal == '') {
                $("#requireEmail_error").html('Please enter email address.');
                $('#requireEmail_error').css('display') == 'block'
                hasError = true;
            }
            else if (!emailReg.test(emailaddressVal)) {
                $("#requireEmail_error").html('Please enter a valid email address.');
                $('#requireEmail_error').css('display') == 'block'
                hasError = true;
            }
            if (hasError == true) {
                return false; 
             }
            else {
                setCookie('videoemail', emailaddressVal, 1);
                $("#hdnEmail").val(emailaddressVal);
                jQuery("#requireEmail").toggle("slow");
                jwplayer('JwplayerContainer').play(true);
            }
        });
    });

} //CLOSE OF CLASS

// Flash Player Version Detection - Rev 1.5
// Detect Client Browser type
// Copyright(c) 2005-2006 Adobe Macromedia Software, LLC. All rights reserved.
var isIE = (navigator.appVersion.indexOf("MSIE") != -1) ? true : false;
var isWin = (navigator.appVersion.toLowerCase().indexOf("win") != -1) ? true : false;
var isOpera = (navigator.userAgent.indexOf("Opera") != -1) ? true : false;

function ControlVersion() {
    var version;
    var axo;
    var e;

    // NOTE : new ActiveXObject(strFoo) throws an exception if strFoo isn't in the registry

    try {
        // version will be set for 7.X or greater players
        axo = new ActiveXObject("ShockwaveFlash.ShockwaveFlash.7");
        version = axo.GetVariable("$version");
    } catch (e) {
    }

    if (!version) {
        try {
            // version will be set for 6.X players only
            axo = new ActiveXObject("ShockwaveFlash.ShockwaveFlash.6");

            // installed player is some revision of 6.0
            // GetVariable("$version") crashes for versions 6.0.22 through 6.0.29,
            // so we have to be careful. 

            // default to the first public version
            version = "WIN 6,0,21,0";

            // throws if AllowScripAccess does not exist (introduced in 6.0r47)		
            axo.AllowScriptAccess = "always";

            // safe to call for 6.0r47 or greater
            version = axo.GetVariable("$version");

        } catch (e) {
        }
    }

    if (!version) {
        try {
            // version will be set for 4.X or 5.X player
            axo = new ActiveXObject("ShockwaveFlash.ShockwaveFlash.3");
            version = axo.GetVariable("$version");
        } catch (e) {
        }
    }

    if (!version) {
        try {
            // version will be set for 3.X player
            axo = new ActiveXObject("ShockwaveFlash.ShockwaveFlash.3");
            version = "WIN 3,0,18,0";
        } catch (e) {
        }
    }

    if (!version) {
        try {
            // version will be set for 2.X player
            axo = new ActiveXObject("ShockwaveFlash.ShockwaveFlash");
            version = "WIN 2,0,0,11";
        } catch (e) {
            version = -1;
        }
    }

    return version;
}

// JavaScript helper required to detect Flash Player PlugIn version information
function GetSwfVer() {
    // NS/Opera version >= 3 check for Flash plugin in plugin array
    var flashVer = -1;

    if (navigator.plugins != null && navigator.plugins.length > 0) {
        if (navigator.plugins["Shockwave Flash 2.0"] || navigator.plugins["Shockwave Flash"]) {
            var swVer2 = navigator.plugins["Shockwave Flash 2.0"] ? " 2.0" : "";
            var flashDescription = navigator.plugins["Shockwave Flash" + swVer2].description;
            var descArray = flashDescription.split(" ");
            var tempArrayMajor = descArray[2].split(".");
            var versionMajor = tempArrayMajor[0];
            var versionMinor = tempArrayMajor[1];
            if (descArray[3] != "") {
                tempArrayMinor = descArray[3].split("r");
            } else {
                tempArrayMinor = descArray[4].split("r");
            }
            var versionRevision = tempArrayMinor[1] > 0 ? tempArrayMinor[1] : 0;
            var flashVer = versionMajor + "." + versionMinor + "." + versionRevision;
        }
    }
    // MSN/WebTV 2.6 supports Flash 4
    else if (navigator.userAgent.toLowerCase().indexOf("webtv/2.6") != -1) flashVer = 4;
    // WebTV 2.5 supports Flash 3
    else if (navigator.userAgent.toLowerCase().indexOf("webtv/2.5") != -1) flashVer = 3;
    // older WebTV supports Flash 2
    else if (navigator.userAgent.toLowerCase().indexOf("webtv") != -1) flashVer = 2;
    else if (isIE && isWin && !isOpera) {
        flashVer = ControlVersion();
    }
    return flashVer;
}

// When called with reqMajorVer, reqMinorVer, reqRevision returns true if that version or greater is available
function DetectFlashVer(reqMajorVer, reqMinorVer, reqRevision) {
    versionStr = GetSwfVer();
    if (versionStr == -1) {
        return false;
    } else if (versionStr != 0) {
        if (isIE && isWin && !isOpera) {
            // Given "WIN 2,0,0,11"
            tempArray = versionStr.split(" "); 	// ["WIN", "2,0,0,11"]
            tempString = tempArray[1]; 		// "2,0,0,11"
            versionArray = tempString.split(","); // ['2', '0', '0', '11']
        } else {
            versionArray = versionStr.split(".");
        }
        var versionMajor = versionArray[0];
        var versionMinor = versionArray[1];
        var versionRevision = versionArray[2];

        // is the major.revision >= requested major.revision AND the minor version >= requested minor
        if (versionMajor > parseFloat(reqMajorVer)) {
            return true;
        } else if (versionMajor == parseFloat(reqMajorVer)) {
            if (versionMinor > parseFloat(reqMinorVer))
                return true;
            else if (versionMinor == parseFloat(reqMinorVer)) {
                if (versionRevision >= parseFloat(reqRevision))
                    return true;
            }
        }
        return false;
    }
}

function AC_AddExtension(src, ext) {
    if (src.indexOf('?') != -1)
        return src.replace(/\?/, ext + '?');
    else
        return src + ext;
}

function AC_Generateobj(objAttrs, params, embedAttrs) {
    var str = '';
    if (isIE && isWin && !isOpera) {
        str += '<object ';
        for (var i in objAttrs)
            str += i + '="' + objAttrs[i] + '" ';
        for (var i in params)
            str += '><param name="' + i + '" value="' + params[i] + '" /> ';
        str += '></object>';
    } else {
        str += '<embed ';
        for (var i in embedAttrs)
            str += i + '="' + embedAttrs[i] + '" ';
        str += '> </embed>';
    }
    document.write(str);

}

function AC_FL_RunContent() {
    var ret =
    AC_GetArgs
    (arguments, ".swf", "movie", "clsid:d27cdb6e-ae6d-11cf-96b8-444553540000"
     , "application/x-shockwave-flash"
    );
    AC_Generateobj(ret.objAttrs, ret.params, ret.embedAttrs);
}

function AC_GetArgs(args, ext, srcParamName, classid, mimeType) {
    var ret = new Object();
    ret.embedAttrs = new Object();
    ret.params = new Object();
    ret.objAttrs = new Object();
    for (var i = 0; i < args.length; i = i + 2) {
        var currArg = args[i].toLowerCase();

        switch (currArg) {
            case "classid":
                break;
            case "pluginspage":
                ret.embedAttrs[args[i]] = args[i + 1];
                break;
            case "src":
            case "movie":
                args[i + 1] = AC_AddExtension(args[i + 1], ext);
                ret.embedAttrs["src"] = args[i + 1];
                ret.params[srcParamName] = args[i + 1];
                break;
            case "onafterupdate":
            case "onbeforeupdate":
            case "onblur":
            case "oncellchange":
            case "onclick":
            case "ondblClick":
            case "ondrag":
            case "ondragend":
            case "ondragenter":
            case "ondragleave":
            case "ondragover":
            case "ondrop":
            case "onfinish":
            case "onfocus":
            case "onhelp":
            case "onmousedown":
            case "onmouseup":
            case "onmouseover":
            case "onmousemove":
            case "onmouseout":
            case "onkeypress":
            case "onkeydown":
            case "onkeyup":
            case "onload":
            case "onlosecapture":
            case "onpropertychange":
            case "onreadystatechange":
            case "onrowsdelete":
            case "onrowenter":
            case "onrowexit":
            case "onrowsinserted":
            case "onstart":
            case "onscroll":
            case "onbeforeeditfocus":
            case "onactivate":
            case "onbeforedeactivate":
            case "ondeactivate":
            case "type":
            case "codebase":
            case "id":
                ret.objAttrs[args[i]] = args[i + 1];
                break;
            case "width":
            case "height":
            case "align":
            case "vspace":
            case "hspace":
            case "class":
            case "title":
            case "accesskey":
            case "name":
            case "tabindex":
                ret.embedAttrs[args[i]] = ret.objAttrs[args[i]] = args[i + 1];
                break;
            default:
                ret.embedAttrs[args[i]] = ret.params[args[i]] = args[i + 1];
        }
    }
    ret.objAttrs["classid"] = classid;
    if (mimeType) ret.embedAttrs["type"] = mimeType;
    return ret;
}

